searchData={"items":[{"type":"module","title":"Membrane.VideoCompositor","doc":"Membrane SDK for [VideoCompositor](https://github.com/membraneframework/video_compositor),\nthat makes advanced, real-time video composition possible.","ref":"Membrane.VideoCompositor.html"},{"type":"module","title":"Input streams - Membrane.VideoCompositor","doc":"Inputs are simply linked as Membrane Pads, no additional requests are required.\nInput registration happens automatically.\nAfter registering and linking input stream VideoCompositor will notify parent with `t:input_registered_msg/0`.\nAfter receiving this message, input can be used in composition.","ref":"Membrane.VideoCompositor.html#module-input-streams"},{"type":"module","title":"Output streams - Membrane.VideoCompositor","doc":"Outputs have to registered before linking.\nTo register output parent sends `t:register_output_msg/0`.\nAfter registering output, VideoCompositor will notify parent with `t:output_registered_msg/0`.\nUsing output in composition is only available after registration.\nOnce VideoCompositor starts producing output stream, it will notify parent with `t:new_output_stream_msg/0`.\nLinking outputs is only available after receiving that message.","ref":"Membrane.VideoCompositor.html#module-output-streams"},{"type":"module","title":"Composition specification - `Scene` - Membrane.VideoCompositor","doc":"To specify what VideoCompositor should render parent should send `t:vc_request/0`.\n`Scene` is a top level specification of what VideoCompositor should render.\n\nAs an example, if two inputs with IDs `\"input_0\"` and `\"input_1\"` and\nsingle output with ID `\"output\"` are registered, sending such `update_scene`\nrequest would result in receiving inputs merged in layout on output:\n```\nscene_update_request = %{\n  type: \"update_scene\",\n  nodes: [\n    %{\n      type: \"built-in\",\n      node_id: \"layout\",\n      transformation: \"tiled_layout\",\n      input_pads: [\"input_0\", \"input_1\"]\n    }\n  ],\n  outputs: [\n    %{\n      output_id: \"output\",\n      input_pad: \"layout\"\n    }\n  ]\n}\n\n{[notify_child: {:video_compositor, {:vc_request, scene_update_request}}]}\n```\nVideoCompositor will notify parent with `t:vc_request_response/0`.\n\nYou can use renderers/nodes to process input streams into outputs.\nVideoCompositor has builtin renders for most common use cases, but you can\nalso register your own shaders, images and websites to tune VideoCompositor for\nspecific business requirements.","ref":"Membrane.VideoCompositor.html#module-composition-specification-scene"},{"type":"module","title":"Pads unlinking - Membrane.VideoCompositor","doc":"Before unlinking pads make remove them from used scene, otherwise VC will crash on pad unlinking.\nInputs/outputs are unregistered automatically on pad unlinking.","ref":"Membrane.VideoCompositor.html#module-pads-unlinking"},{"type":"module","title":"API reference - Membrane.VideoCompositor","doc":"You can find more detailed [API reference here](https://github.com/membraneframework/video_compositor/wiki/API-%E2%80%90-general#update-scene).\nOnly `update_scene` and `register_renderer` request are available (`inputs`/`outputs` registration, `start` and `init` is done by SDK).","ref":"Membrane.VideoCompositor.html#module-api-reference"},{"type":"module","title":"General concepts - Membrane.VideoCompositor","doc":"[General concepts of scene are explained here](https://github.com/membraneframework/video_compositor/wiki/Main-concepts).","ref":"Membrane.VideoCompositor.html#module-general-concepts"},{"type":"module","title":"Examples - Membrane.VideoCompositor","doc":"Examples can be found in `examples` directory of Membrane VideoCompositor Plugin.\n`Scene` API usage examples can be found in [VideoCompositor repo](https://github.com/membraneframework/video_compositor/tree/master/examples).","ref":"Membrane.VideoCompositor.html#module-examples"},{"type":"module","title":"Bin options - Membrane.VideoCompositor","doc":"Passed via struct `t:Membrane.VideoCompositor.t/0`\n\n- `framerate`  \n\n  ```\n  Membrane.RawVideo.framerate_t()\n  ```\n  \n  ***Required***  \n  Framerate of VideoCompositor outputs.\n\n\n- `port_range`  \n\n  ```\n  port_range()\n  ```\n  \n  Default value: `{6000, 10000}`  \n  Port range in which input and output streams would try to be registered.\n  If all ports in range will be used, VideoCompositor will crash on input/output registration.\n\n\n\n- `init_web_renderer?`  \n\n  ```\n  boolean()\n  ```\n  \n  Default value: `true`  \n  Enables web rendering for VideoCompositor.\n  If set to false, attempts to register and use web renderers will fail.\n\n\n\n- `stream_fallback_timeout`  \n\n  ```\n  Membrane.Time.t()\n  ```\n  \n  Default value: `10000000000`  \n  Timeout that defines when the VideoCompositor should switch to fallback on the input stream that stopped sending frames.\n\n\n\n- `start_composing_strategy`  \n\n  ```\n  :on_init | :on_message\n  ```\n  \n  Default value: `:on_init`  \n  Specifies when VideoCompositor starts composing frames.\n  In `:on_message` strategy, `:start_composing` message has to be sent to start composing.\n\n\n\n- `vc_server_config`  \n\n  ```\n  :start_on_random_port\n  | {:start_on_port, :inet.port_number()}\n  | {:already_started, :inet.port_number()}\n  ```\n  \n  Default value: `:start_on_random_port`  \n  Defines how VideoCompositor bin should start-up VideoCompositor server.\n  \n  There are three available options:\n  - :start_on_random_port - VC server is automatically started on port randomly chosen from port_range\n  - :start_on_port - VC server is automatically started on specified port\n  - :already_started - VideoCompositor bin assumes, that VC server is already started, initialized and should be\n  available at specified port. Useful for sharing VC server between multiple pipelines or running custom version\n  of VC server.","ref":"Membrane.VideoCompositor.html#module-bin-options"},{"type":"module","title":"Pads - Membrane.VideoCompositor","doc":"### `:input`\n\nAccepted formats:\n```\n%Membrane.H264{alignment: :nalu, stream_structure: :annexb}\n```\n\nDirection: | `:input`\nAvailability: | `:on_request`\nPad options:\n\n- `input_id`  \n\n  ```\n  input_id()\n  ```\n  \n  ***Required***  \n  \n\n\n\n### `:output`\n\nAccepted formats:\n```\n%Membrane.H264{alignment: :nalu, stream_structure: :annexb}\n```\n\nDirection: | `:output`\nAvailability: | `:on_request`\nPad options:\n\n- `output_id`  \n\n  ```\n  output_id()\n  ```\n  \n  ***Required***","ref":"Membrane.VideoCompositor.html#module-pads"},{"type":"function","title":"Membrane.VideoCompositor.options/0","doc":"Returns description of options available for this module","ref":"Membrane.VideoCompositor.html#options/0"},{"type":"type","title":"Membrane.VideoCompositor.encoder_preset/0","doc":"Preset of VideoCompositor output video encoder.\nSee [FFmpeg docs](https://trac.ffmpeg.org/wiki/Encode/H.264#Preset) to learn more.","ref":"Membrane.VideoCompositor.html#t:encoder_preset/0"},{"type":"type","title":"Membrane.VideoCompositor.input_id/0","doc":"Input stream id, used in scene after adding input stream.","ref":"Membrane.VideoCompositor.html#t:input_id/0"},{"type":"type","title":"Membrane.VideoCompositor.input_pad_opts/0","doc":"Options for pad `:input`","ref":"Membrane.VideoCompositor.html#t:input_pad_opts/0"},{"type":"type","title":"Membrane.VideoCompositor.input_registered_msg/0","doc":"Notification sent to parent after VideoCompositor receives\nthe first frame from the input stream (registered on input pad link).\n\nInput can be used in `scene` only after registration.","ref":"Membrane.VideoCompositor.html#t:input_registered_msg/0"},{"type":"type","title":"Membrane.VideoCompositor.new_output_stream_msg/0","doc":"Notification sent to parent after VideoCompositor starts producing streams\nand in ready to link output pad.\n\nSee \"Output streams\" section in doc for more information.","ref":"Membrane.VideoCompositor.html#t:new_output_stream_msg/0"},{"type":"type","title":"Membrane.VideoCompositor.output_id/0","doc":"Output stream id, used in scene after adding output stream.","ref":"Membrane.VideoCompositor.html#t:output_id/0"},{"type":"type","title":"Membrane.VideoCompositor.output_pad_opts/0","doc":"Options for pad `:output`","ref":"Membrane.VideoCompositor.html#t:output_pad_opts/0"},{"type":"type","title":"Membrane.VideoCompositor.output_registered_msg/0","doc":"Notification sent to parent after output registration.\n\nOutput can be used in `scene` only after registration.","ref":"Membrane.VideoCompositor.html#t:output_registered_msg/0"},{"type":"type","title":"Membrane.VideoCompositor.port_range/0","doc":"Range in which VideoCompositor search available ports.\n\nThis range should be at least a few times wider then expected sum\nof inputs and outputs.","ref":"Membrane.VideoCompositor.html#t:port_range/0"},{"type":"type","title":"Membrane.VideoCompositor.register_output_msg/0","doc":"Notification sent to VideoCompositor to register output stream.\n\nSee \"Output streams\" section in the documentation for more information.","ref":"Membrane.VideoCompositor.html#t:register_output_msg/0"},{"type":"type","title":"Membrane.VideoCompositor.request_body/0","doc":"Elixir translated body of VideoCompositor requests.\n\nElixir types are mapped into JSON types:\n- map -> object\n- atom -> string\n\nThis request body:\n```\n%{\n  type: \"update_scene\",\n  nodes: [\n    %{\n      type: \"built-in\",\n      node_id: \"layout\",\n      transformation: \"tiled_layout\",\n      input_pads: [\"input_0\", \"input_1\"]\n    }\n  ],\n  outputs: [\n    %{\n      output_id: \"output\",\n      input_pad: \"layout\"\n    }\n  ]\n}\n```\nwill translate into the following JSON:\n```json\n{\n  \"type\": \"update_scene\",\n  \"nodes\": [\n    {\n      \"type\": \"built-in\",\n      \"node_id\": \"layout\",\n      \"transformation\": \"tiled_layout\",\n      \"input_pads\": [\"input_0\", \"input_1\"]\n    }\n  ],\n  outputs: [\n    {\n      \"output_id\": \"output\",\n      \"input_pad\": \"layout\"\n    }\n  ]\n}\n```","ref":"Membrane.VideoCompositor.html#t:request_body/0"},{"type":"type","title":"Membrane.VideoCompositor.t/0","doc":"Struct containing options for `Membrane.VideoCompositor`","ref":"Membrane.VideoCompositor.html#t:t/0"},{"type":"type","title":"Membrane.VideoCompositor.vc_request/0","doc":"Request send to VideoCompositor.\n\nUser of SDK should only send `update_scene` or `register_renderer` requests.\n[API reference can be found here](https://github.com/membraneframework/video_compositor/wiki/API-%E2%80%90-general#update-scene).","ref":"Membrane.VideoCompositor.html#t:vc_request/0"},{"type":"type","title":"Membrane.VideoCompositor.vc_request_response/0","doc":"VideoCompositor request response.","ref":"Membrane.VideoCompositor.html#t:vc_request_response/0"},{"type":"module","title":"Membrane.VideoCompositor.Context","doc":"Context of VideoCompositor. Specifies VideoCompositor inputs and outputs.","ref":"Membrane.VideoCompositor.Context.html"},{"type":"type","title":"Membrane.VideoCompositor.Context.t/0","doc":"Context of VideoCompositor. Specifies VideoCompositor inputs and outputs.","ref":"Membrane.VideoCompositor.Context.html#t:t/0"},{"type":"module","title":"Membrane.VideoCompositor.Context.InputStream","doc":"Context of single VideoCompositor input.","ref":"Membrane.VideoCompositor.Context.InputStream.html"},{"type":"type","title":"Membrane.VideoCompositor.Context.InputStream.t/0","doc":"Context of single VideoCompositor input.","ref":"Membrane.VideoCompositor.Context.InputStream.html#t:t/0"},{"type":"module","title":"Membrane.VideoCompositor.Context.OutputStream","doc":"Context of single VideoCompositor output.","ref":"Membrane.VideoCompositor.Context.OutputStream.html"},{"type":"type","title":"Membrane.VideoCompositor.Context.OutputStream.t/0","doc":"Context of single VideoCompositor output.","ref":"Membrane.VideoCompositor.Context.OutputStream.html#t:t/0"},{"type":"module","title":"Membrane.VideoCompositor.OutputOptions","doc":"Options of VideoCompositor output.","ref":"Membrane.VideoCompositor.OutputOptions.html"},{"type":"type","title":"Membrane.VideoCompositor.OutputOptions.encoder_preset/0","doc":"After rendering VideoCompositors outputs are encoded.\nChanging encoder preset can substantially impact output quality as well as CPU usage.\nSee [FFmpeg docs](https://trac.ffmpeg.org/wiki/Encode/H.264#Preset) to learn more.","ref":"Membrane.VideoCompositor.OutputOptions.html#t:encoder_preset/0"},{"type":"type","title":"Membrane.VideoCompositor.OutputOptions.t/0","doc":"Options of VideoCompositor output.","ref":"Membrane.VideoCompositor.OutputOptions.html#t:t/0"},{"type":"extras","title":"Membrane Video Compositor Plugin","doc":"# Membrane Video Compositor Plugin\n\n[![Hex.pm](https://img.shields.io/hexpm/v/membrane_video_compositor_plugin.svg)](https://hex.pm/packages/membrane_video_compositor_plugin)\n[![API Docs](https://img.shields.io/badge/api-docs-yellow.svg?style=flat)](https://hexdocs.pm/membrane_video_compositor_plugin)\n[![CircleCI](https://dl.circleci.com/status-badge/img/gh/membraneframework/membrane_video_compositor_plugin/tree/master.svg?style=svg)](https://dl.circleci.com/status-badge/redirect/gh/membraneframework/membrane_video_compositor_plugin/tree/master)\n\nMembrane SDK for VideoCompositor, that takes multiple input streams, transforms them according to provided transformations and composes them into output streams / videos.\n\nIt is part of [Membrane Multimedia Framework](https://membrane.stream).","ref":"readme.html"},{"type":"extras","title":"Installation - Membrane Video Compositor Plugin","doc":"The package can be installed by adding `membrane_video_compositor_plugin` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:membrane_video_compositor_plugin, \"~> 0.8.0\"}\n  ]\nend\n```\n\nVideoCompositor requires having locally installed:\n\n- [FFmpeg 6.0](https://ffmpeg.org/download.html) - for streaming inputs / outputs to VideoCompositor\n- [wget](https://www.gnu.org/software/wget/) - for downloading VideoCompositor binary file\n- [tar](https://www.gnu.org/software/tar/) - for decompressing VideoCompositor binary file","ref":"readme.html#installation"},{"type":"extras","title":"Examples - Membrane Video Compositor Plugin","doc":"Examples can be found in `examples` directory.\n\nTo run example run:\n\n1. `cd examples`\n2. `mix deps.get`\n3. `mix run lib/[example_name].exs`\n\n#","ref":"readme.html#examples"},{"type":"extras","title":"Layout with shader example - Membrane Video Compositor Plugin","doc":"The example presents dynamically added video arranged onto a tiled layout and \"twisted\" with the simple shader. Shaders can be used to create custom visual effects.\n\n#","ref":"readme.html#layout-with-shader-example"},{"type":"extras","title":"Transition example - Membrane Video Compositor Plugin","doc":"The example presents dynamic transition of input videos. Transitions are used for smooth, dynamical animations.\n\n#","ref":"readme.html#transition-example"},{"type":"extras","title":"Dynamic outputs example - Membrane Video Compositor Plugin","doc":"The example presents dynamic outputs linking.\nMultiple outputs are useful for live-streaming for multiple platforms (e.g. different layout for mobile devices), target resolutions\nor any other case, when user want to process input videos differently.","ref":"readme.html#dynamic-outputs-example"},{"type":"extras","title":"LICENSE","doc":"Apache License\n                           Version 2.0, January 2004\n                        http://www.apache.org/licenses/\n\n   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION\n\n   1. Definitions.\n\n      \"License\" shall mean the terms and conditions for use, reproduction,\n      and distribution as defined by Sections 1 through 9 of this document.\n\n      \"Licensor\" shall mean the copyright owner or entity authorized by\n      the copyright owner that is granting the License.\n\n      \"Legal Entity\" shall mean the union of the acting entity and all\n      other entities that control, are controlled by, or are under common\n      control with that entity. For the purposes of this definition,\n      \"control\" means (i) the power, direct or indirect, to cause the\n      direction or management of such entity, whether by contract or\n      otherwise, or (ii) ownership of fifty percent (50%) or more of the\n      outstanding shares, or (iii) beneficial ownership of such entity.\n\n      \"You\" (or \"Your\") shall mean an individual or Legal Entity\n      exercising permissions granted by this License.\n\n      \"Source\" form shall mean the preferred form for making modifications,\n      including but not limited to software source code, documentation\n      source, and configuration files.\n\n      \"Object\" form shall mean any form resulting from mechanical\n      transformation or translation of a Source form, including but\n      not limited to compiled object code, generated documentation,\n      and conversions to other media types.\n\n      \"Work\" shall mean the work of authorship, whether in Source or\n      Object form, made available under the License, as indicated by a\n      copyright notice that is included in or attached to the work\n      (an example is provided in the Appendix below).\n\n      \"Derivative Works\" shall mean any work, whether in Source or Object\n      form, that is based on (or derived from) the Work and for which the\n      editorial revisions, annotations, elaborations, or other modifications\n      represent, as a whole, an original work of authorship. For the purposes\n      of this License, Derivative Works shall not include works that remain\n      separable from, or merely link (or bind by name) to the interfaces of,\n      the Work and Derivative Works thereof.\n\n      \"Contribution\" shall mean any work of authorship, including\n      the original version of the Work and any modifications or additions\n      to that Work or Derivative Works thereof, that is intentionally\n      submitted to Licensor for inclusion in the Work by the copyright owner\n      or by an individual or Legal Entity authorized to submit on behalf of\n      the copyright owner. For the purposes of this definition, \"submitted\"\n      means any form of electronic, verbal, or written communication sent\n      to the Licensor or its representatives, including but not limited to\n      communication on electronic mailing lists, source code control systems,\n      and issue tracking systems that are managed by, or on behalf of, the\n      Licensor for the purpose of discussing and improving the Work, but\n      excluding communication that is conspicuously marked or otherwise\n      designated in writing by the copyright owner as \"Not a Contribution.\"\n\n      \"Contributor\" shall mean Licensor and any individual or Legal Entity\n      on behalf of whom a Contribution has been received by Licensor and\n      subsequently incorporated within the Work.\n\n   2. Grant of Copyright License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      copyright license to reproduce, prepare Derivative Works of,\n      publicly display, publicly perform, sublicense, and distribute the\n      Work and such Derivative Works in Source or Object form.\n\n   3. Grant of Patent License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      (except as stated in this section) patent license to make, have made,\n      use, offer to sell, sell, import, and otherwise transfer the Work,\n      where such license applies only to those patent claims licensable\n      by such Contributor that are necessarily infringed by their\n      Contribution(s) alone or by combination of their Contribution(s)\n      with the Work to which such Contribution(s) was submitted. If You\n      institute patent litigation against any entity (including a\n      cross-claim or counterclaim in a lawsuit) alleging that the Work\n      or a Contribution incorporated within the Work constitutes direct\n      or contributory patent infringement, then any patent licenses\n      granted to You under this License for that Work shall terminate\n      as of the date such litigation is filed.\n\n   4. Redistribution. You may reproduce and distribute copies of the\n      Work or Derivative Works thereof in any medium, with or without\n      modifications, and in Source or Object form, provided that You\n      meet the following conditions:\n\n      (a) You must give any other recipients of the Work or\n          Derivative Works a copy of this License; and\n\n      (b) You must cause any modified files to carry prominent notices\n          stating that You changed the files; and\n\n      (c) You must retain, in the Source form of any Derivative Works\n          that You distribute, all copyright, patent, trademark, and\n          attribution notices from the Source form of the Work,\n          excluding those notices that do not pertain to any part of\n          the Derivative Works; and\n\n      (d) If the Work includes a \"NOTICE\" text file as part of its\n          distribution, then any Derivative Works that You distribute must\n          include a readable copy of the attribution notices contained\n          within such NOTICE file, excluding those notices that do not\n          pertain to any part of the Derivative Works, in at least one\n          of the following places: within a NOTICE text file distributed\n          as part of the Derivative Works; within the Source form or\n          documentation, if provided along with the Derivative Works; or,\n          within a display generated by the Derivative Works, if and\n          wherever such third-party notices normally appear. The contents\n          of the NOTICE file are for informational purposes only and\n          do not modify the License. You may add Your own attribution\n          notices within Derivative Works that You distribute, alongside\n          or as an addendum to the NOTICE text from the Work, provided\n          that such additional attribution notices cannot be construed\n          as modifying the License.\n\n      You may add Your own copyright statement to Your modifications and\n      may provide additional or different license terms and conditions\n      for use, reproduction, or distribution of Your modifications, or\n      for any such Derivative Works as a whole, provided Your use,\n      reproduction, and distribution of the Work otherwise complies with\n      the conditions stated in this License.\n\n   5. Submission of Contributions. Unless You explicitly state otherwise,\n      any Contribution intentionally submitted for inclusion in the Work\n      by You to the Licensor shall be under the terms and conditions of\n      this License, without any additional terms or conditions.\n      Notwithstanding the above, nothing herein shall supersede or modify\n      the terms of any separate license agreement you may have executed\n      with Licensor regarding such Contributions.\n\n   6. Trademarks. This License does not grant permission to use the trade\n      names, trademarks, service marks, or product names of the Licensor,\n      except as required for reasonable and customary use in describing the\n      origin of the Work and reproducing the content of the NOTICE file.\n\n   7. Disclaimer of Warranty. Unless required by applicable law or\n      agreed to in writing, Licensor provides the Work (and each\n      Contributor provides its Contributions) on an \"AS IS\" BASIS,\n      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\n      implied, including, without limitation, any warranties or conditions\n      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A\n      PARTICULAR PURPOSE. You are solely responsible for determining the\n      appropriateness of using or redistributing the Work and assume any\n      risks associated with Your exercise of permissions under this License.\n\n   8. Limitation of Liability. In no event and under no legal theory,\n      whether in tort (including negligence), contract, or otherwise,\n      unless required by applicable law (such as deliberate and grossly\n      negligent acts) or agreed to in writing, shall any Contributor be\n      liable to You for damages, including any direct, indirect, special,\n      incidental, or consequential damages of any character arising as a\n      result of this License or out of the use or inability to use the\n      Work (including but not limited to damages for loss of goodwill,\n      work stoppage, computer failure or malfunction, or any and all\n      other commercial damages or losses), even if such Contributor\n      has been advised of the possibility of such damages.\n\n   9. Accepting Warranty or Additional Liability. While redistributing\n      the Work or Derivative Works thereof, You may choose to offer,\n      and charge a fee for, acceptance of support, warranty, indemnity,\n      or other liability obligations and/or rights consistent with this\n      License. However, in accepting such obligations, You may act only\n      on Your own behalf and on Your sole responsibility, not on behalf\n      of any other Contributor, and only if You agree to indemnify,\n      defend, and hold each Contributor harmless for any liability\n      incurred by, or claims asserted against, such Contributor by reason\n      of your accepting any such warranty or additional liability.\n\n   END OF TERMS AND CONDITIONS\n\n   APPENDIX: How to apply the Apache License to your work.\n\n      To apply the Apache License to your work, attach the following\n      boilerplate notice, with the fields enclosed by brackets \"[]\"\n      replaced with your own identifying information. (Don't include\n      the brackets!)  The text should be enclosed in the appropriate\n      comment syntax for the file format. We also recommend that a\n      file or class name and description of purpose be included on the\n      same \"printed page\" as the copyright notice for easier\n      identification within third-party archives.\n\n   Copyright 2022 Software Mansion\n\n   Licensed under the Apache License, Version 2.0 (the \"License\");\n   you may not use this file except in compliance with the License.\n   You may obtain a copy of the License at\n\n       http://www.apache.org/licenses/LICENSE-2.0\n\n   Unless required by applicable law or agreed to in writing, software\n   distributed under the License is distributed on an \"AS IS\" BASIS,\n   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n   See the License for the specific language governing permissions and\n   limitations under the License.","ref":"license.html"}],"content_type":"text/markdown"}